﻿----------
--[[BigSay 超级%T
## Author: tg123]]

-- ADDED: doneykoo (doneykoo@gmail.com), 2013
function IsUsingLocaleZH()
	if GetLocale() == "zhTW" then
		return true;
	elseif  GetLocale() == "zhCN" then
		return true;
	else
		return false;
	end
end

-- ADDED: doneykoo (doneykoo@gmail.com), 2013
function SmartNumber(value)
	if not value then
		return ""
	end
	if type(value) ~= "number" then
		return value
	end
	
	if value >= 10000000 or value <= -10000000 then
		return ("%.1fm"):format(value / 1000000)
	elseif value >= 1000000 or value <= -1000000 then
		return ("%.2fm"):format(value / 1000000)
	elseif value >= 100000 or value <= -100000 then
		return ("%.0fk"):format(value / 1000)
	elseif value >= 10000 or value <= -10000 then
		return ("%.1fk"):format(value / 1000)
	else
		return value
	end
end

local BigSay={
	["%%S"]=function()
		return GetRaidTargetIndex("target") and "{".._G["RAID_TARGET_"..GetRaidTargetIndex("target")].."}" or ""
	end,
	["%%TT"]=function()
		return UnitName("targettarget") or ""
	end,
	["%%R"]=function()
		return UnitRace("target") or ""
	end,
	["%%C"]=function()
		return UnitClass("target")~=UnitName("target") and UnitClass("target") or ""
	end,
	-- ADDED: doneykoo (doneykoo@gmail.com), 2012
	-- position and zone
	-- 坐标与区域
	["%%X"]=function()
		local px,py=GetPlayerMapPosition("player")
		return px and py and string.format("<%d,%d>",px*100,py*100) or ""
	end,
	["%%Z"]=function()
		return GetRealZoneText() or ""
	end,
	-- ADDED: doneykoo (doneykoo@gmail.com), 2012
	-- health percentage, one digit fixed.
	-- 小数点1位的百分比血量
	["%%P"]=function()
		return UnitHealthMax("target")>0 and string.format("%.1f%%%%", 100*UnitHealth("target")/UnitHealthMax("target")) or ""
	end,
	["%%H"]=function()
		-- FIXED: doneykoo (doneykoo@gmail.com), 2013
		-- use smart format, because unit health has been large value since WOW 5.x MOP
		return SmartNumber( UnitHealth("target") ).."/"..SmartNumber( UnitHealthMax("target") )
		-- return UnitHealth("target").."/"..UnitHealthMax("target")
	end,
	["%%M"]=function()
		-- FIXED: doneykoo (doneykoo@gmail.com), 2013
		-- use smart format, because unit health has been large value since WOW 5.x MOP
		return SmartNumber( UnitMana("target") ).."/"..SmartNumber( UnitManaMax("target") )
		-- return UnitMana("target").."/"..UnitManaMax("target")
	end,
	
	-- ADDED: doneykoo (doneykoo@gmail.com), 2012
	-- info of mouseover and target
	-- 以下几个以%O开头，当鼠标悬停存在时，返回鼠标悬停单位（mouseover）的信息；
	-- 鼠标悬停不存在时，返回当前目标单位（target）的信息。
	-- 信息包括：名字,种族,标记,职业,血量百分比,血量。
	["%%OT"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return UnitName(unitid) or ""
	end,
	["%%OR"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return UnitRace(unitid) or ""
	end,
	["%%OS"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return GetRaidTargetIndex(unitid) and "{".._G["RAID_TARGET_"..GetRaidTargetIndex(unitid)].."}" or ""
	end,
	["%%OC"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return UnitClass(unitid)~=UnitName(unitid) and UnitClass(unitid) or ""
	end,
	["%%OP"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return UnitHealthMax(unitid)>0 and string.format("%.1f%%%%", 100*UnitHealth(unitid)/UnitHealthMax(unitid)) or ""
	end,
	["%%OH"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return SmartNumber( UnitHealth(unitid) ).."/"..SmartNumber( UnitHealthMax(unitid) )
		-- return UnitHealth(unitid).."/"..UnitHealthMax(unitid)
	end,
	["%%OM"]=function()
		local unitid = "target"
		if (UnitExists("mouseover")) then unitid = "mouseover" end
		return SmartNumber( UnitMana(unitid) ).."/"..SmartNumber( UnitManaMax(unitid) )
		-- return UnitMana(unitid).."/"..UnitManaMax(unitid)
	end,
}
local oldSendChatMessage=SendChatMessage
SendChatMessage=function(arg1,...)
	for i,v in pairs(BigSay) do
		arg1=string.gsub(arg1,i,v() or "")
	end
	

oldSendChatMessage(arg1,...)
end